com.sun.pdfview

## Class ThumbPanel

- java.lang.Object
- - java.awt.Component
  - - java.awt.Container
    - - javax.swing.JComponent
      - - javax.swing.JPanel
        - - com.sun.pdfview.ThumbPanel

All Implemented Interfaces:
  java.awt.image.ImageObserver, java.awt.MenuContainer, java.io.Serializable, java.lang.Runnable, javax.accessibility.Accessible, javax.swing.Scrollable

    public class ThumbPanel
    extends javax.swing.JPanel
    implements java.lang.Runnable, javax.swing.Scrollable, java.awt.image.ImageObserver

A panel of thumbnails, one for each page of a PDFFile. You can add a PageChangeListener to be informed of when the user clicks one of the pages.

See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class javax.swing.JPanel

`javax.swing.JPanel.AccessibleJPanel`

### Nested classes/interfaces inherited from class javax.swing.JComponent

`javax.swing.JComponent.AccessibleJComponent`

### Nested classes/interfaces inherited from class java.awt.Container

`java.awt.Container.AccessibleAWTContainer`

### Nested classes/interfaces inherited from class java.awt.Component

`java.awt.Component.AccessibleAWTComponent, java.awt.Component.BaselineResizeBehavior, java.awt.Component.BltBufferStrategy, java.awt.Component.FlipBufferStrategy`

### Field Summary

### Fields inherited from class javax.swing.JComponent

`accessibleContext, listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

### Fields inherited from class java.awt.Component

`BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

### Fields inherited from interface java.awt.image.ImageObserver

`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

### Constructor Summary

Constructors
Constructor and Description
`ThumbPanel(PDFFile file)` Creates a new ThumbPanel based on a PDFFile.

### Method Summary

Methods
`void` `addPageChangeListener(PageChangeListener pl)` Adds a PageChangeListener to receive notification of page clicks.
`java.awt.Dimension` `getPreferredScrollableViewportSize()`
`int` `getScrollableBlockIncrement(java.awt.Rectangle visrect, int orientation, int direction)`
`boolean` `getScrollableTracksViewportHeight()`
`boolean` `getScrollableTracksViewportWidth()`
`int` `getScrollableUnitIncrement(java.awt.Rectangle visrect, int orientation, int direction)`
`void` `handleClick(int x, int y)` Handles a mouse click in the panel.
`boolean` `imageUpdate(java.awt.Image img, int infoflags, int x, int y, int width, int height)` Handles notification of any image updates.
`void` `pageShown(int pagenum)` Sets the currently viewed page, indicates it with a highlight border, and makes sure the thumbnail is visible.
`void` `paint(java.awt.Graphics g)` Updates the positions of the thumbnails, and draws them to the screen.
`void` `removePageChangeListener(PageChangeListener pl)` Removes a PageChangeListener from the notification list.
`void` `run()` Renders each of the pages in the PDFFile into a thumbnail.
`void` `setDefaultWidth(int width)` Sets the default width of an un-processed thumbnail.
`void` `showPage(int pagenum)` Notifies the listeners that a page has been selected.
`void` `stop()` Stops the render thread.

### Methods inherited from class javax.swing.JPanel

`getAccessibleContext, getUI, getUIClassID, paramString, setUI, updateUI`

### Methods inherited from class javax.swing.JComponent

`addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paintBorder, paintChildren, paintComponent, paintImmediately, paintImmediately, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

### Methods inherited from class java.awt.Container

`add, add, add, add, add, addContainerListener, addImpl, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusDownCycle, validate, validateTree`

### Methods inherited from class java.awt.Component

`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, hide, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### ThumbPanel

    public ThumbPanel(PDFFile file)

Creates a new ThumbPanel based on a PDFFile. The file may be null. Automatically starts rendering thumbnails for that file.

### Method Detail

#### run

    public void run()

Renders each of the pages in the PDFFile into a thumbnail. Preferentially works on the needdrawn thumbnail, otherwise, go in order.

Specified by:
  `run` in interface `java.lang.Runnable`

#### addPageChangeListener

    public void addPageChangeListener(PageChangeListener pl)

Adds a PageChangeListener to receive notification of page clicks.

#### removePageChangeListener

    public void removePageChangeListener(PageChangeListener pl)

Removes a PageChangeListener from the notification list.

#### stop

    public void stop()

Stops the render thread. Be sure to call this before dropping a ThumbPanel.

#### setDefaultWidth

    public void setDefaultWidth(int width)

Sets the default width of an un-processed thumbnail.

Parameters:
  `width` - the width of an unknown thumbnail, in pixels.

#### handleClick

    public void handleClick(int x,
                   int y)

Handles a mouse click in the panel. Figures out which page was clicked, and calls showPage.

Parameters:
  `x` - the x coordinate of the mouse click
  `y` - the y coordinate of the mouse click

#### pageShown

    public void pageShown(int pagenum)

Sets the currently viewed page, indicates it with a highlight border, and makes sure the thumbnail is visible.

#### showPage

    public void showPage(int pagenum)

Notifies the listeners that a page has been selected. Performs the notification in the AWT thread. Also highlights the selected page. Does this first so that feedback is immediate.

#### paint

    public void paint(java.awt.Graphics g)

Updates the positions of the thumbnails, and draws them to the screen.

Overrides:
  `paint` in class `javax.swing.JComponent`

#### imageUpdate

    public boolean imageUpdate(java.awt.Image img,
                      int infoflags,
                      int x,
                      int y,
                      int width,
                      int height)

Handles notification of any image updates. Not used any more.

Specified by:
  `imageUpdate` in interface `java.awt.image.ImageObserver`
Overrides:
  `imageUpdate` in class `java.awt.Component`

#### getPreferredScrollableViewportSize

    public java.awt.Dimension getPreferredScrollableViewportSize()

Specified by:
  `getPreferredScrollableViewportSize` in interface `javax.swing.Scrollable`

#### getScrollableBlockIncrement

    public int getScrollableBlockIncrement(java.awt.Rectangle visrect,
                                  int orientation,
                                  int direction)

Specified by:
  `getScrollableBlockIncrement` in interface `javax.swing.Scrollable`

#### getScrollableTracksViewportHeight

    public boolean getScrollableTracksViewportHeight()

Specified by:
  `getScrollableTracksViewportHeight` in interface `javax.swing.Scrollable`

#### getScrollableTracksViewportWidth

    public boolean getScrollableTracksViewportWidth()

Specified by:
  `getScrollableTracksViewportWidth` in interface `javax.swing.Scrollable`

#### getScrollableUnitIncrement

    public int getScrollableUnitIncrement(java.awt.Rectangle visrect,
                                 int orientation,
                                 int direction)

Specified by:
  `getScrollableUnitIncrement` in interface `javax.swing.Scrollable`